﻿using System;
using System.Diagnostics;
using System.Runtime.InteropServices;
using BuiltToRoam.Hosting;

namespace BuiltToRoam
{
    [Guid("C3C44476-A1CE-403E-AFE2-D53EF618B139")]
    internal class Profiler : Native.IActiveScriptProfilerCallback2
    {
        public void OnFunctionEnterByName(string pwszFunctionName, Native.ProfilerScriptType type)
        {
            Debug.WriteLine("Profiler.OnFunctionEnterByName: {0}, {1}", pwszFunctionName, type);
        }

        public void OnFunctionExitByName(string pwszFunctionName, Native.ProfilerScriptType type)
        {
            Debug.WriteLine("Profiler.OnFunctionExitByName: {0}, {1}", pwszFunctionName, type);
        }

        public void Initialize(uint dwContext)
        {
            Debug.WriteLine("Profiler.Initialize: {0}", dwContext);
        }

        public void Shutdown(uint hrReason)
        {
            Debug.WriteLine("Profiler.Shutdown: {0}", hrReason);
        }

        public void ScriptCompiled(int scriptId, Native.ProfilerScriptType type, IntPtr pIDebugDocumentContext)
        {
            Debug.WriteLine("Profiler.ScriptCompiled: {0}, {1}", scriptId, type);
        }

        public void FunctionCompiled(int functionId, int scriptId, string pwszFunctionName, string pwszFunctionNameHint, IntPtr pIDebugDocumentContext)
        {
            Debug.WriteLine("Profiler.FunctionCompiled: {0}, {1}, {2}, {3}", functionId, scriptId, pwszFunctionName, pwszFunctionNameHint);
        }

        public void OnFunctionEnter(int scriptId, int functionId)
        {
            Debug.WriteLine("Profiler.OnFunctionEnter: {0}, {1}", scriptId, functionId);
        }

        public void OnFunctionExit(int scriptId, int functionId)
        {
            Debug.WriteLine("Profiler.OnFunctionExit: {0}, {1}", scriptId, functionId);
        }
    }
}
